
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android程序锁的实现以及逻辑_Android / iVAN</title>

    <meta name="description" content="Android程序锁的实现以及逻辑_Android 本项目是一个比较有趣的项目源码,可以给其他项目加锁,程序锁的原理是一个&quot;看门狗&quot;的服务定时监视顶层activity,如果activity对应的包名是之前上锁的应用程序的,则弹出一个页面要求输入解锁密码. 效果如下: 1.基本思路 ①.创建已加锁应用的数据库(字段:_id,packagename),如果应用已加锁,将加锁应用的包名维护到数据库中 ②.已加锁+未加锁 == 手机中所有应用(AppInfoProvider) 2.已加锁和未加锁的数据适配器 class MyAdapt ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android程序锁的实现以及逻辑_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本项目是一个比较有趣的项目源码，可以给其他项目加锁，程序锁的原理是一个“看门狗”的服务定时监视顶层activity，如果activity对应的包名是之前上锁的应用程序的，则弹出一个页面要求输入解锁密码。</p>
<p>效果如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTAyMjE0NDkzODc4Ny5wbmc=.jpg"></p>
<p><strong>1.基本思路</strong></p>
<p>①.创建已加锁应用的数据库(字段:_id,packagename),如果应用已加锁,将加锁应用的包名维护到数据库中</p>
<p>②.已加锁+未加锁 == 手机中所有应用(AppInfoProvider)</p>
<p><strong>2.已加锁和未加锁的数据适配器</strong></p>
<pre>
class MyAdapter extends BaseAdapter{
 private boolean isLock;
 /**
 * @param isLock 用于区分已加锁和未加锁应用的标示 true已加锁数据适配器 false未加锁数据适配器
 */
 public MyAdapter(boolean isLock) {
 this.isLock = isLock;
 }
 @Override
 public int getCount() {
 if(isLock){
  tv_lock.setText("已加锁应用:"+mLockList.size());
  return mLockList.size();
 }else{
  tv_unlock.setText("未加锁应用:"+mUnLockList.size());
  return mUnLockList.size();
 }
 }

 @Override
 public AppInfo getItem(int position) {
 if(isLock){
  return mLockList.get(position);
 }else{
  return mUnLockList.get(position);
 }
 }

 @Override
 public long getItemId(int position) {
 return position;
 }

 @Override
 public View getView(int position, View convertView, ViewGroup parent) {
 ViewHolder holder = null;
 if(convertView == null){
  convertView = View.inflate(getApplicationContext(), R.layout.listview_islock_item, null);
  holder = new ViewHolder();
  holder.iv_icon = (ImageView) convertView.findViewById(R.id.iv_icon);
  holder.tv_name = (TextView) convertView.findViewById(R.id.tv_name);
  holder.iv_lock = (ImageView) convertView.findViewById(R.id.iv_lock);

  convertView.setTag(holder);
 }else{
  holder = (ViewHolder) convertView.getTag();
 }
 final AppInfo appInfo = getItem(position);
 final View animationView = convertView;

 holder.iv_icon.setBackgroundDrawable(appInfo.icon);
 holder.tv_name.setText(appInfo.name);
 if(isLock){
  holder.iv_lock.setBackgroundResource(R.drawable.lock);
 }else{
  holder.iv_lock.setBackgroundResource(R.drawable.unlock);
 }
 holder.iv_lock.setOnClickListener(new OnClickListener() {
  @Override
  public void onClick(View v) {
  //添加动画效果,动画默认是非阻塞的,所以执行动画的同时,动画以下的代码也会执行
  animationView.startAnimation(mTranslateAnimation);//500毫秒
  //对动画执行过程做事件监听,监听到动画执行完成后,再去移除集合中的数据,操作数据库,刷新界面
  mTranslateAnimation.setAnimationListener(new AnimationListener() {
   @Override
   public void onAnimationStart(Animation animation) {
   //动画开始的是调用方法
   }
   @Override
   public void onAnimationRepeat(Animation animation) {
   //动画重复时候调用方法
   }
   //动画执行结束后调用方法
   @Override
   public void onAnimationEnd(Animation animation) {
   if(isLock){
    //已加锁------&gt;未加锁过程
    //1.已加锁集合删除一个,未加锁集合添加一个,对象就是getItem方法获取的对象
    mLockList.remove(appInfo);
    mUnLockList.add(appInfo);
    //2.从已加锁的数据库中删除一条数据
    mDao.delete(appInfo.packageName);
    //3.刷新数据适配器
    mLockAdapter.notifyDataSetChanged();
   }else{
    //未加锁------&gt;已加锁过程
    //1.已加锁集合添加一个,未加锁集合移除一个,对象就是getItem方法获取的对象
    mLockList.add(appInfo);
    mUnLockList.remove(appInfo);
    //2.从已加锁的数据库中插入一条数据
    mDao.insert(appInfo.packageName);
    //3.刷新数据适配器
    mUnLockAdapter.notifyDataSetChanged();
   }
   }
  });
  }
 });
 return convertView;
 }
}
</pre>
<pre>
mLockAdapter = new MyAdapter(true);
lv_lock.setAdapter(mLockAdapter);

mUnLockAdapter = new MyAdapter(false);
lv_unlock.setAdapter(mUnLockAdapter);</pre>
<p><strong>3.已加锁和未加锁条目点击事件处理</strong></p>
<pre>
holder.iv_lock.setOnClickListener(new OnClickListener() {
 @Override
 public void onClick(View v) {
 //添加动画效果,动画默认是非阻塞的,所以执行动画的同时,动画以下的代码也会执行
 animationView.startAnimation(mTranslateAnimation);//500毫秒
 //对动画执行过程做事件监听,监听到动画执行完成后,再去移除集合中的数据,操作数据库,刷新界面
 mTranslateAnimation.setAnimationListener(new AnimationListener() {
  @Override
  public void onAnimationStart(Animation animation) {
  //动画开始的是调用方法
  }
  @Override
  public void onAnimationRepeat(Animation animation) {
  //动画重复时候调用方法
  }
  //动画执行结束后调用方法
  @Override
  public void onAnimationEnd(Animation animation) {
  if(isLock){
   //已加锁------&gt;未加锁过程
   //1.已加锁集合删除一个,未加锁集合添加一个,对象就是getItem方法获取的对象
   mLockList.remove(appInfo);
   mUnLockList.add(appInfo);
   //2.从已加锁的数据库中删除一条数据
   mDao.delete(appInfo.packageName);
   //3.刷新数据适配器
   mLockAdapter.notifyDataSetChanged();
  }else{
   //未加锁------&gt;已加锁过程
   //1.已加锁集合添加一个,未加锁集合移除一个,对象就是getItem方法获取的对象
   mLockList.add(appInfo);
   mUnLockList.remove(appInfo);
   //2.从已加锁的数据库中插入一条数据
   mDao.insert(appInfo.packageName);
   //3.刷新数据适配器
   mUnLockAdapter.notifyDataSetChanged();
  }
  }
 });
 }
});
</pre>
<p><strong>4.程序锁必须在服务中去维护</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTAyMjE0NTAyMDg2My5wbmc=.jpg"></p>
<p>①基本思路</p>
<ol>
<li>判断当前开启的应用(现在手机可见任务栈)</li>
<li>如果开启的应用在已加锁的列表中,弹出拦截界面</li>
<li>看门狗服务,一直(死循环(子线程,可控))对开启的应用做监听</li>
</ol>

<pre>
public class WatchDogService extends Service {
 private boolean isWatch;
 private AppLockDao mDao;
 private List&lt;String&gt; mPacknameList;
 private InnerReceiver mInnerReceiver;
 private String mSkipPackagename;
 private MyContentObserver mContentObserver;
 @Override
 public void onCreate() {
 //维护一个看门狗的死循环,让其时刻监测现在开启的应用,是否为程序锁中要去拦截的应用
 mDao = AppLockDao.getInstance(this);
 isWatch = true;
 watch();

 IntentFilter intentFilter = new IntentFilter();
 intentFilter.addAction("android.intent.action.SKIP");

 mInnerReceiver = new InnerReceiver();
 registerReceiver(mInnerReceiver, intentFilter);

 //注册一个内容观察者,观察数据库的变化,一旦数据有删除或者添加,则需要让mPacknameList重新获取一次数据
 mContentObserver = new MyContentObserver(new Handler());
 getContentResolver().registerContentObserver(
  Uri.parse("content://applock/change"), true, mContentObserver);
 super.onCreate();
 }

 class MyContentObserver extends ContentObserver{

 public MyContentObserver(Handler handler) {
  super(handler);
 }

 //一旦数据库发生改变时候调用方法,重新获取包名所在集合的数据
 @Override
 public void onChange(boolean selfChange) {
  new Thread(){
  public void run() {
   mPacknameList = mDao.findAll();
  };
  }.start();
  super.onChange(selfChange);
 }
 }

 class InnerReceiver extends BroadcastReceiver{
 @Override
 public void onReceive(Context context, Intent intent) {
  //获取发送广播过程中传递过来的包名,跳过次包名检测过程
  mSkipPackagename = intent.getStringExtra("packagename");
 }
 }

 private void watch() {
 //1,子线程中,开启一个可控死循环
 new Thread(){
  public void run() {
  mPacknameList = mDao.findAll();
  while(isWatch){
   //2.监测现在正在开启的应用,任务栈
   //3.获取activity管理者对象
   ActivityManager am = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
   //4.获取正在开启应用的任务栈
   List&lt;RunningTaskInfo&gt; runningTasks = am.getRunningTasks(1);
   RunningTaskInfo runningTaskInfo = runningTasks.get(0);
   //5.获取栈顶的activity,然后在获取此activity所在应用的包名
   String packagename = runningTaskInfo.topActivity.getPackageName();

   //如果任务栈指向应用有切换,将mSkipPackagename空字符串

   //6.拿此包名在已加锁的包名集合中去做比对,如果包含次包名,则需要弹出拦截界面
   if(mPacknameList.contains(packagename)){
   //如果现在检测的程序,以及解锁了,则不需要去弹出拦截界面
   if(!packagename.equals(mSkipPackagename)){
    //7,弹出拦截界面
    Intent intent = new Intent(getApplicationContext(),EnterPsdActivity.class);
    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    intent.putExtra("packagename", packagename);
    startActivity(intent);
   }
   }
   //睡眠一下,时间片轮转
   try {
   Thread.sleep(500);
   } catch (InterruptedException e) {
   e.printStackTrace();
   }
  }
  };
 }.start();

 }
 @Override
 public IBinder onBind(Intent arg0) {
 return null;
 }
 @Override
 public void onDestroy() {
 //停止看门狗循环
 isWatch = false;
 //注销广播接受者
 if(mInnerReceiver!=null){
  unregisterReceiver(mInnerReceiver);
 }
 //注销内容观察者
 if(mContentObserver!=null){
  getContentResolver().unregisterContentObserver(mContentObserver);
 }
 super.onDestroy();
 }
}
</pre>
<pre>
public class EnterPsdActivity extends Activity {
 private String packagename;
 private TextView tv_app_name;
 private ImageView iv_app_icon;
 private EditText et_psd;
 private Button bt_submit;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
 super.onCreate(savedInstanceState);
 //获取包名
 packagename = getIntent().getStringExtra("packagename");
 setContentView(R.layout.activity_enter_psd);
 initUI();
 initData();
 }

 private void initData() {
 //通过传递过来的包名获取拦截应用的图标以及名称
 PackageManager pm = getPackageManager();
 try {
  ApplicationInfo applicationInfo = pm.getApplicationInfo(packagename,0);
  Drawable icon = applicationInfo.loadIcon(pm);
  iv_app_icon.setBackgroundDrawable(icon);
  tv_app_name.setText(applicationInfo.loadLabel(pm).toString());
 } catch (NameNotFoundException e) {
  e.printStackTrace();
 }

 bt_submit.setOnClickListener(new OnClickListener() {
  @Override
  public void onClick(View v) {
  String psd = et_psd.getText().toString();
  if(!TextUtils.isEmpty(psd)){
   if(psd.equals("123")){
   //解锁,进入应用,告知看门口不要再去监听以及解锁的应用,发送广播
   Intent intent = new Intent("android.intent.action.SKIP");
   intent.putExtra("packagename",packagename);
   sendBroadcast(intent);

   finish();
   }else{
   ToastUtil.show(getApplicationContext(), "密码错误");
   }
  }else{
   ToastUtil.show(getApplicationContext(), "请输入密码");
  }
  }
 });
 }

 private void initUI() {
 tv_app_name = (TextView) findViewById(R.id.tv_app_name);
 iv_app_icon = (ImageView) findViewById(R.id.iv_app_icon);

 et_psd = (EditText) findViewById(R.id.et_psd);
 bt_submit = (Button) findViewById(R.id.bt_submit);
 }

 @Override
 public void onBackPressed() {
 //通过隐式意图,跳转到桌面
 Intent intent = new Intent(Intent.ACTION_MAIN);
 intent.addCategory(Intent.CATEGORY_HOME);
 startActivity(intent);
 super.onBackPressed();
 }
}
</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTAyMjE0NTEyOTA3Ny5wbmc=.jpg"></p>
<p>5.隐藏最近打开的activity</p>
<pre>
&lt;activity
  android:excludeFromRecents="true"
  android:name="com.itheima.mobilesafe.EnterPwdActivity"
  android:launchMode="singleInstance" /&gt;
</pre>
<p>以上就是本文的全部内容，希望对大家的学习有所帮助，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android<br />
                    ，                android程序锁实现<br />
                    ，                程序锁<br />
                                    android程序锁开发<br />
                                    android程序锁实现、android5.0程序锁实现、android 程序锁、android程序锁源码、python实现逻辑回归，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:28:13</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f%e9%94%81/" title="程序锁">程序锁</a>, <a href="https://www.iamivan.net/tag/android%e7%a8%8b%e5%ba%8f%e9%94%81%e5%ae%9e%e7%8e%b0/" title="android程序锁实现">android程序锁实现</a>, <a href="https://www.iamivan.net/tag/android%e7%a8%8b%e5%ba%8f%e9%94%81%e5%bc%80%e5%8f%91/" title="android程序锁开发">android程序锁开发</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android程序锁的实现以及逻辑_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP20P1b.html" rel="bookmark">Android程序锁的实现以及逻辑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本项目是一个比较有趣的项目源码,可以给其他项目加锁,程序锁的原理是一个&quot;看门狗&quot;的服务定时监视顶层activity,如果activity对应的包名是之前上锁的应用程序的,则弹出一个页面要求输入解锁密码. 效果如下: 1.基本思路 ①.创建已加锁应用的数据库(字段:_id,packagename),如果应用已加锁,将加锁应用的包名维护到数据库中 ②.已加锁+未加锁 == 手机中所有应用(AppInfoProvider) 2.已加锁和未加锁的数据适配器 class MyAdapter ex			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn842kb.html" rel="bookmark">Android开发之开门狗在程序锁中的应用实例&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之开门狗在程序锁中的应用方法.分享给大家供大家参考,具体如下: protected static final String TAG = &quot;WatchDogService&quot;; private AppLockDao dao; private List&lt;String&gt; lockApps; private ActivityManager am; private Intent lockappintent; @Override public IBinde			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKk2a5b.html" rel="bookmark">浅谈AnDroidDraw&plus;DroidDraw实现Android程序UI设计的分析说明&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AnDroidDraw 是一个与 DroidDraw 集成的 Android 应用程序,它允许你从 DroidDraw 应用 程序下载你的 GUIs, 也允许你在一个 Android 设备上预览你的 GUIs1.先下载安装DroidDraw,我使用的版本是droiddraw-r1b222.下载AnDroidDraw.apk,并在模拟器上进行安装,安装步骤如下: 1)使用cmd进入命令行窗口,进入你安装的android-sdk下的platform-tools目录,如图: 2)使用: adb ins			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0PVJPM.html" rel="bookmark">android安全问题（二） 程序锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				某些人有时候会有这样一种需求,小A下载了个软件,只是软件中的美女过于诱惑与暴露,所以他不想让 别人知道这是个什么软件,起码不想让别人打开浏览.而这款软件又没有锁,任何人都可以打开,肿么办呢? 如果打开它的时候需要输入密码,那该多好阿!于是,程序锁这种应用就产生了 程序锁不是最近才有 的,很久之前android就有这种apk了 这一期我们来苛刻如何实现程序加锁功能 首先,我们先明 确一下我们要做的程序具有什么功能 1可以选择需要加锁的程序 2可以设置密码 3可以关 闭程序锁 这里作为演示,我们就尽			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq6W4z.html" rel="bookmark">Android 开发程序锁应用简单实例&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.基本思路 ①.创建已加锁应用的数据库(字段:_id,packagename),如果应用已加锁,将加锁应用的包名维护到数据库中 ②.已加锁+未加锁 == 手机中所有应用(AppInfoProvider) 2.已加锁和未加锁的数据适配器 class MyAdapter extends BaseAdapter{ private boolean isLock; /** * @param isLock 用于区分已加锁和未加锁应用的标示 true已加锁数据适配器 false未加锁数据适配器 */ pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj8dlZp.html" rel="bookmark">Android程序开发仿新版QQ锁屏下弹窗功能&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新版的qq,可以在锁屏下弹窗显示qq消息,正好目前在做的项目也需要这一功能.经过各种试验和资料查找,终于实现,过程不难,但是却有一些地方需要注意. 下面是实现过程. 1.使用Activity,而不是View QQ的弹窗一开始我以为是悬浮View,用WindowManager去添加,但是无论如何就是不显示,后来在朋友提示下换成Activity来实现,在锁屏状态下就能弹窗了. 2.Activity的设置 Activity需要进行以下设置,才可以在锁屏状态下弹窗. 首先是onCreate方法,需要添加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7ZXnz.html" rel="bookmark">android手机程序锁如何重复广播重复解锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android手机程序锁如何重复广播重复解锁 求助,现在实现了在我写的应用中给手机中的软件加锁,应用接收到广播之后,打开程序进入程序锁页面后输入密码进入应用,我想问一下,怎么实现解锁后,不停止service的情况下,下次进入这个程序还继续输入密码,重复输入过程,只要我的应用中不给他解锁,他就一直有输入密码页面,我试了一下,输入密码正确后,加锁页面就finish掉后,进入应用,但是他又弹出来了.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLLPVM.html" rel="bookmark">推荐几本Android程序员必读书籍&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android是一种基于Linux的自由及开放源代码的操作系统,主要使用于移动设备,如智能手机和平板电脑,由Google公司和开放手机联盟领导及开发,从语言上来看,Android应用开发基于的是Java语言,但是这都是我们要自己下功夫去学习的事情. 不管你是Android菜鸟还是Android大神,一定能够找到一本适合自己阅读的书籍,抓紧来看看吧! 高尔基曾说&quot;书是人类进步的阶梯&quot;,今天小编就为大家整理了一些优秀Android程序员都会阅读的书籍,帮助大家成为一个优秀的程序员 第1本书			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9jqyXp.html" rel="bookmark">Android屏幕锁屏弹窗的正确姿势DEMO详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章给大家介绍了Android程序开发仿新版QQ锁屏下弹窗功能.今天通过本文给大家分享android锁屏弹窗的正确姿势. 最近在做一个关于屏幕锁屏悬浮窗的功能,于是在网上搜索了很多安卓屏幕锁屏的相关资料,鉴于网上的资料比较零碎,所以我在这里进行整理总结.本文将从以下两点对屏幕锁屏进行解析: 1. 如何监听系统屏幕锁屏 2. 如何在锁屏界面弹出悬浮窗 如何监听系统屏幕锁屏 经过总结,监听系统的锁屏可以通过以下两种方式: 1) 代码直接判定 2) 接收广播 1) 代码直接判定 代码判断方式,也			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkG5jp.html" rel="bookmark" class="title">如何解决word输入法不能切换</a>
					<div>
						  1.打开Word,点击&quot;文件 -&gt; 选项&quot;, 2.在&quot;选项&quot;窗口,单击&quot;高级&quot;,然后从右侧细节窗口找到&quot;输入法控制处于活 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjGQ8M.html" rel="bookmark" class="title">用户需求与设计师的理想设计&colon;如何把握用户需求</a>
					<div>
						文章描述:面向用户需求的产品设计. 著名的用户体验大师 Mark Husrt 在不久前的东西论坛 - 跨界与融合中讲了一个故事.1989 年夏天,南非的一位广告人 Trevor Field 在偶然的机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyYEdb.html" rel="bookmark" class="title">WIN95日志钩子&lpar;JournalRecord Hook&rpar;的使用</a>
					<div>
						钩子是WINDOWS中消息处理机制的一个要点,通过安装各种钩子,应用程序能够设置相应的子例程来监视系统里的消息传递以及在这些消息到达目标窗口程序之前处理它们.钩子的种类很多,每种钩子可以截获并处理相应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPK7oz.html" rel="bookmark" class="title">脚本系统&colon;c&plus;&plus;内嵌python</a>
					<div>
						// liquidx.cpp : Defines the entry point for the console application. // #include &quot;stdafx.h&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7GdZM.html" rel="bookmark" class="title">JBuilder2005实现重构之类继承体系间</a>
					<div>
						在JBuilder中通过重构将值域.方法在类的继承体系中上推下移,是非常容易的操作.这了说明这种重构功能,我们先来看下面的类继承体系: 图15 类的继承类图 Animal类是Cat和Horse和父类, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlREqOz.html" rel="bookmark" class="title">win7系统怎么修改本地磁盘名称</a>
					<div>
						  win7系统怎么修改本地磁盘名称? 下面小编教大家具体设置方法. 1.在Win7系统双击&quot;计算机&quot;图标,打开&quot;windows资源管理器&quot;; 2.将需要改变名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRq7Nz.html" rel="bookmark" class="title">JS&plus;CSS实现的拖动分页效果实例</a>
					<div>
						  本文实例讲述了JS+CSS实现拖动分页效果的方法.分享给大家供大家参考.具体实现方法如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWWRyb.html" rel="bookmark" class="title">Tomcat配置 Tomcat6怎么安装</a>
					<div>
						Tomcat是Apache基金会的Jakarta项目中的一个核心项目,由Apache.Sun和其他一些公司及个人共同开发而成.它是一个 集成了Servlet容器的免费开源Web服务器,所以既能解析JS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Jy0p.html" rel="bookmark" class="title">雨林木风win7系统卸载软件提示没有权限怎么办</a>
					<div>
						  故障图: 解决方法: 1.首先打开软件安装目录,找到软件卸载程序,一般名称为Uninstall.exe,也有可能是含&quot;卸载&quot;的中文软件,然后鼠标右击它选择&quot;以管理员身 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo75QVb.html" rel="bookmark" class="title">PHP操作MYSQL数据库</a>
					<div>
						MYSQL接口配置 Linux 必须在编译时加上一个-with-mysql选项 windows 通过一个DLL文件提供了相应的扩展 共同配置 不管使用是哪一种操作系统,都必须在php.ini文件里启用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7L7Wp.html" rel="bookmark" class="title">shell-在命令行中设置开发者选项</a>
					<div>
						问题描述 在命令行中设置开发者选项 在一些设备上开发者选项被隐藏了(不是android4.2的原因,是做这个rom的厂家干的) 那么如何使用它呢? 最好是在shell 中将之开启:我要用的是显示触摸操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7QZoz.html" rel="bookmark" class="title">problem中Project&amp;amp&semi;&num;39&semi;XX&amp;amp&semi;&num;39&semi;is missing required library&colon;&amp;amp&semi;&num;39&semi;&lbrack;路径&rsqb;&bsol;XXX&period;jar&amp;amp&semi;&num;39&semi;解决方法</a>
					<div>
						起因:        今天在接手同事做的一个项目时,发现用Myeclipse部署后,项目里有不少网页出现红叉,逐个修改完后,项目理应不再显示红叉,但奇怪的是,项目所有的子文件都没错误,项目根目录却有个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNvaVz.html" rel="bookmark" class="title">easyui分页问题，急求</a>
					<div>
						问题描述 easyui分页问题,急求 将pagesize设为15行后,底下分页显示为15行,但是第一次进入页面显示还是只有10条记录,点击下一页后显示为15条记录,再返回第一页15记录显示正常,求解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRxvjb.html" rel="bookmark" class="title">黑客教你怎样用Excel剿灭DLL木马</a>
					<div>
						DLL木马是依靠DLL文件来作恶的,木马运行时不会在进程列表出现 新的进程,而且很多DLL木马还 插入到系统关键进程中(无法终止),即使能被杀毒软件检测出来也无法查杀,这给系统安全带来极大的威胁.如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXej6z.html" rel="bookmark" class="title">帝国还是共和？</a>
					<div>
						摘要: 上次发布会后有人说我像老罗,最近剪了个头,又有人说我像金正恩,即便被安排到最后环节,但刚一上场的李楠依旧引爆了全场. 4个多月前,魅族发布了Connect to Meizu这个新硬件合作 &q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEYwOM.html" rel="bookmark" class="title">Yii2框架整合Xunsearch搜索引擎的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了Yii2框架整合Xunsearch搜索引擎的方法.分享给大家供大家参考,具体如下: 公司一直用的YII2框架,然后要做一个中文搜索引擎,所有想的Xunsearch这个项目,之前有文章提到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYOonp.html" rel="bookmark" class="title">世界各地GSM和LTE移动网络存在严重安全漏洞</a>
					<div>
						US-CERT昨日发出警告,管理和互联世界各地移动网络的软件应用程序可能会受到一个远程执行代码(RCE)漏洞影响,可以让攻击者接管关键设备.该漏洞(CVE-2016-5080)被发现在ASN1C代码编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdR1xNb.html" rel="bookmark" class="title">eclipse 碰到了个怪问题</a>
					<div>
						问题描述 安装的是最新的eclipsekepler,还装了Googlepluginforeclipse,GWT,正常情况下界面是这样的:但是有时候最小化eclipse后,再打开eclipse,就变成这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqW3Ob.html" rel="bookmark" class="title">java 静态和非静态的一点疑问</a>
					<div>
						问题描述 java非静态方法不能访问静态成员,处于什么考虑? 解决方案 解决方案二:可以访问呀.解决方案三:能访问啊,楼主问题搞错了都解决方案四:说反了...不光JAVA,不然逻辑上过不去解决方案五: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze02W9p.html" rel="bookmark" class="title">盘古即刻合并董事长为副部级干部：姓王 背景不详</a>
					<div>
						腾讯科技讯 8月1日消息,国家队http://www.aliyun.com/zixun/aggregation/24832.html&quot;&gt;盘古搜索和即刻搜索合并传闻再起,今日有消息称,盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYvlNb.html" rel="bookmark" class="title">Jquery与JS两种方法仿twitter&sol;新浪微博 高度自适应无缝滚动实现代码&lowbar;jquery</a>
					<div>
						第一最好不相见,如此便可不相恋.第二最好不相知,如此便可不相思. 第三最好不相伴,如此便可不相欠.第四最好不相惜,如此便可不相忆. 作相思. 第一最好不相见,如此便可不相恋.第二最好不相知,如此便可不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7D3eM.html" rel="bookmark" class="title">使用Python获取Linux系统的各种信息&lowbar;python</a>
					<div>
						在本文中,我们将会探索使用Python编程语言工具来检索Linux系统各种信息.走你. 哪个Python版本? 当我提及Python,所指的就是CPython 2(准确的是2.7).我会显式提醒那些相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZmvAz.html" rel="bookmark" class="title">浅谈EasyUI中Treegrid节点的删除&lowbar;jquery</a>
					<div>
						EasyUI中的删除很简单,一般直接复制粘贴就行. 下面是对树节点的删除. 复制代码 代码如下: // 删除 function removes() {     var rows = ruletreeg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NZ9op.html" rel="bookmark" class="title">百度钱包如何提现？百度钱包提现方法图解</a>
					<div>
						1.我们打开电脑中的百度钱包登录界面之后填写密码点击登录 2.然后我们会看到自己百度钱包的账户余额,然后在我们的余额的右侧分别为[充值]和[提现],点击&quot;提现&quot; 如下图所示 3.提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZKkQb.html" rel="bookmark" class="title">java用poi做导入excel 2007在正式环境报错</a>
					<div>
						问题描述 java用poi做导入excel 2007在正式环境报错 解决方案 你确定你的文件路径没有错误吗. 错误信息应该是 你tmp文件路径错误了.你要看下正式环境的 文件地址.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgAGaz.html" rel="bookmark" class="title">用大数据撬动停车难&OpenCurlyDoubleQuote;顽石&rdquo;</a>
					<div>
						日前,北京市交通委起草了&lt;北京市机动车停车管理条例(草案送审稿)&gt;.自4月11日至5月10日面向社会公开征求意见.在拟定的条例中,违法停放的机动车将被罚款和扣分&quot;双处罚&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwy9DvM.html" rel="bookmark" class="title">危机公关珍珑棋局：天猫、星巴克、8点20发</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在&lt;天龙八部&gt;中逍遥派 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRLrqz.html" rel="bookmark" class="title">F5：让跨云应用顺畅交付</a>
					<div>
						2017年,注定是云计算技术不平凡的一年.仅仅在几年前,云计算还只是几家大厂商倡导的概念:而在今天,无论规模大小,用户与解决方案提供商早已将视线聚焦在如何通过云计算为企业带来更多核心竞争力.更值得注意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YaEYb.html" rel="bookmark" class="title">javascript 出生日期和身份证判断大全&lowbar;时间日期</a>
					<div>
						if(document.form1.csrq.value==&quot;&quot;){ alert(&quot;请填写出生日期!&quot;); document.form1.csrq.focus( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPBRZp.html" rel="bookmark" class="title">典型的国外B2B网络营销理论</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 互联网已经走进我们的生活,网络经济的发展推动了网络营销的飞 速发展.许多企业建立了电子商务网站或利用互联网开展各种业务活动,特别是随着B2B电子商务的发 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
